<?php

require_once 'include/api/SugarApi.php';

use \Sugarcrm\Sugarcrm\custom\PxRoutines\LBExtensions\Templates\Helpers\TemplateProcessor;

class PX_FlowchartTemplatesApi extends SugarApi
{
    public function registerApiRest()
    {
        return array(
            'validateTemplateText' => array(
                'reqType' => 'POST',
                'path' => array('lbTemplate', 'validateTemplate'),
                'pathVars' => array('', ''),
                'method' => 'validateTemplateText',
            ),
        );
    }

    private $validatedEngineTypes = array('smarty');

    public function validateTemplateText(ServiceBase $api, array $args) {
        $validationResult = array(
            'errorCode' => 0,
            'errorText' => '',
            'errorLine' => 0
        );
        if($this->needsValidation($args)){
            $templateBean = BeanFactory::getBean('PX_FlowchartTemplates');
            $templateBean->tpl_engine_type = $args['tpl_engine_type'];
            $templateBean->context = $args['context'];
            $templateBean->html_body = $args['html_body'];
            $templateBean->name = $args['name'];


            $templateEngine = new TemplateProcessor($templateBean);
            try{
                $templateEngine->process();
            }catch(Exception $e){
                $validationResult = array(
                    'errorCode' => $e->getCode(),
                    'errorText' => strip_tags($e->getMessage()),
                    'errorLine' => $e->getLine()
                );
            }
        }

        return $validationResult;
    }

    private function needsValidation($args){
        return  !empty($args['tpl_engine_type']) && in_array($args['tpl_engine_type'], $this->validatedEngineTypes) &&
                !empty($args['html_body']);
    }
}
