<?php
$module_name = 'PX_FlowchartTemplates';
$viewdefs[$module_name]['base']['view']['preview'] = array(
    //check_out_lb_template
    'panels' => array(
        array(
            'name' => 'panel_header',
            'label' => 'LBL_RECORD_HEADER',
            'header' => true,
            'fields' => array(
                array(
                    'name' => 'picture',
                    'type' => 'avatar',
                    'width' => 42,
                    'height' => 42,
                    'dismiss_label' => true,
                    'readonly' => true,
                ),
                'name',
                array(
                    'name' => 'favorite',
                    'label' => 'LBL_FAVORITE',
                    'type' => 'favorite',
                    'readonly' => true,
                    'dismiss_label' => true,
                ),
            ),
        ),
        array(
            'name' => 'panel_body',
            'label' => 'LBL_RECORD_BODY',
            'columns' => 2,
            'labelsOnTop' => true,
            'placeholders' => true,
            'newTab' => false,
            'panelDefault' => 'expanded',
            'fields' => array(
                array(
                    'name' => 'context',
                    'type' => 'px-context',
                    'options' => array(
                        'label' => array(
                            'placeholder' => 'Display label',
                            'tooltip' => 'Display label',
                            'display' => true,
                            'dismiss_label' => true
                        ),
                        'name' => array(
                            'placeholder' => 'System name',
                            'tooltip' => 'System name',
                            'dismiss_label' => true
                        ),
                        'controlGroup' => array(
                            'display' => true
                        )
                    )
                ),
                'tpl_engine_type',
                array(
                    'name' => 'html_body',
                    'type' => 'htmleditable_tinymce',
                    'span' => 12,
                    'dismiss_label' => true,
                    'fieldSelector' => 'body',
                    'tinyConfig' => array(
                        'height' => '400',
                        'plugins' => 'code,textcolor,insertdatetime,table,link,preview,paste,searchreplace,directionality,image',
                        'toolbar' => [
                            'code | bold italic underline strikethrough ' . '| bullist numlist | alignleft aligncenter alignright alignjustify ' . '| forecolor backcolor | fontsizeselect | cleanup removeformat ' . '| image | link unlink | table'
                        ],
                        'valid_elements' => '*[*]',
                    ),
                ),
            ),
        ),
        array(
            'name' => 'panel_hidden',
            'label' => 'LBL_SHOW_MORE',
            'hide' => true,
            'columns' => 2,
            'labelsOnTop' => true,
            'placeholders' => true,
            'newTab' => false,
            'panelDefault' => 'expanded',
            'fields' => array(
                array(
                    'name' => 'description',
                    'span' => 12,
                ),
                array(
                    'name' => 'date_modified_by',
                    'readonly' => true,
                    'inline' => true,
                    'type' => 'fieldset',
                    'label' => 'LBL_DATE_MODIFIED',
                    'fields' => array(
                        array(
                            'name' => 'date_modified',
                        ),
                        array(
                            'type' => 'label',
                            'default_value' => 'LBL_BY',
                        ),
                        array(
                            'name' => 'modified_by_name',
                        ),
                    ),
                ),
                array(
                    'name' => 'date_entered_by',
                    'readonly' => true,
                    'inline' => true,
                    'type' => 'fieldset',
                    'label' => 'LBL_DATE_ENTERED',
                    'fields' => array(
                        array(
                            'name' => 'date_entered',
                        ),
                        array(
                            'type' => 'label',
                            'default_value' => 'LBL_BY',
                        ),
                        array(
                            'name' => 'created_by_name',
                        ),
                    ),
                ),
            ),
        ),
    ),
    'templateMeta' => array(
        'useTabs' => false,
    ),
);
