<?php

$dictionary['PX_FlowchartTemplates'] = array(
    'table' => 'px_flowcharttemplates',
    'audited' => true,
    'activity_enabled' => false,
    'duplicate_merge' => true,
    'fields' => array(
        'tpl_engine_type' => array(
            'name' => 'tpl_engine_type',
            'vname' => 'LBL_TPL_ENGINE_TYPE',
            'type' => 'enum',
            'options' => 'px_lbtemplates_tpl_engine_type',
            'len' => '50',
            'hideacl' => true,
        ),
        'context' => array(
            'name' => 'context',
            'vname' => 'LBL_CONTEXT',
            'type' => 'text',
            'required' => false,
            'reportable' => false,
            'hideacl' => true,
        ),
        'html_body' => array(
            'name' => 'html_body',
            'vname' => 'LBL_HTML_BODY',
            'type' => 'longtext',
            'comment' => 'HTML formatted email body to be used in resulting email',
            'reportable' => false,
            'hideacl' => true,
        ),
    ),
    'relationships' => array(),
    'optimistic_locking' => false,
    'unified_search' => true,
    'ignore_templates' => array(
        'lockable_fields',
        'following',
    ),
);

if(!class_exists('VardefManager')){
    require_once 'include/SugarObjects/VardefManager.php';
}
VardefManager::createVardef('PX_FlowchartTemplates', 'PX_FlowchartTemplates', array('basic'));

$dictionary['PX_FlowchartTemplates']['duplicate_check'] = array(
    'enabled' => true,
    'PX_FlowchartTemplatesFilterDuplicateCheck' => array(
        'filter_template' => array(
            array(
                'name' => array(
                    '$starts' => '$name',
                ),
            ),
        ),
        'ranking_fields' => array(
            array(
                'in_field_name' => 'name',
                'dupe_field_name' => 'name',
            ),
        ),
    ),
);

$dictionary['PX_FlowchartTemplates']['fields']['name']['hideacl'] = true;

if(class_exists('PX_NeedToDoEventTypes')) {
    $dictionary['PX_FlowchartTemplates']['fields']['px_needtodoeventtypes'] = array(
        'name' => 'px_needtodoeventtypes',
        'type' => 'link',
        'relationship' => 'px_needtodoeventtypes_lb_template',
        'module' => 'PX_NeedToDoEventTypes',
        'bean_name' => 'PX_NeedToDoEventTypes',
        'source' => 'non-db',
        'vname' => 'LBL_PX_NEEDTODOEVENTTYPES',
    );
}